<?xml version="1.0"?>
<!-- ============================================================
     XSL stylesheet that contains the parametrised layout
     templates for the image gallery.

     $Id: layout.xsl,v 1.4 2001/12/10 22:51:24 liw Exp $
     ================================================================ -->

  
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  version="1.0">
  
  <!-- **************************************************************** -->
  <!-- MAIN PAGE -->

  <!-- Creates the head element -->
  <xsl:template name="layout-index-head">
    <head>
      <title><xsl:value-of select="folder[1]/name"/></title>
      <link rel="stylesheet" href="lodju.css" type="text/css"/>
    </head>
  </xsl:template>

  <!-- ================================================================ -->
  <!-- Creates the document header -->
  <xsl:template name="layout-index-header">
    <table width="90%" border="0" cellpadding="0" cellspacing="0" 
           bgcolor="#ffffff">
      <tr>
	<td align="left" valign="bottom">
	    <img src="logo_top.gif" alt="Logo top" border="0"/>
	</td>
	<td></td>
      </tr>
      <tr>
	<td align="left" background="fade_bg.gif">
	    <img src="logo_middle.gif" border="0" alt="Logo middle"/>
	</td>
	<td align="right" background="fade.gif">
	    <span class="title">
	    	<xsl:value-of select="folder[1]/name"/>
	    </span>
	</td>
      </tr>
      <tr>
	<td align="left" valign="top">
	    <img src="logo_bottom.gif" border="0" alt="Logot bottom"/>
	</td>
<!--
	<td align="right">
	    <a href="#">&lt;&lt; Previous</a>
	    <xsl:text> </xsl:text>
	    <a href="#">1</a>
	    <xsl:text> | </xsl:text>
	    <a href="#">2</a>
	    <xsl:text> </xsl:text>
	    <a href="#">Next >></a>
	</td>
-->
      </tr>
    </table>
  </xsl:template>
  
  <xsl:template name="layout-index-footer">
    <table width="90%" border="0" cellpadding="0" cellspacing="0" 
           bgcolor="#ffffff">
<!--
      <tr>
	<td colspan="2">
	    <a href="#">&lt;&lt; Previous</a>
	    <xsl:text> </xsl:text>
	    <a href="#">1</a>
	    <xsl:text> | </xsl:text>
	    <a href="#">2</a> 
	    <xsl:text> </xsl:text>
	    <a href="#">Next >></a>
	</td>
      </tr>
-->
      <tr>
	<td background="footerfill.gif" width="20%">
	  <img src="clear.gif" width="1" height="9" alt=""/>
	</td>
	<td background="footerfade.gif" align="right">
	  <img src="clear.gif" width="1" height="9" alt=""/>
	</td>
      </tr>
    </table>
  </xsl:template>

  <!-- **************************************************************** -->
  <!-- FOLDER PAGE -->

  <!-- Creates the head element -->
  <xsl:template name="layout-folder-head">
    <head>
      <title>Image gallery - <xsl:value-of select="name"/></title>
      <link rel="stylesheet" href="style/lodju.css" media="screen"
	type="text/css" title="Lodju default style"/>
    </head>
  </xsl:template>

  <!-- ================================================================ -->
  <!-- Creates the folder header -->
  <xsl:template name="layout-folder-header">
    <div>
      <table width="100%" border="0">
	<tr>
	  <td height="101" valign="middle"
	    class="layout-folder-header">
	    <p>Lodju image gallery</p>
	  </td>
	</tr>
      </table>
    </div>
  </xsl:template>

  <!-- ================================================================ -->
  <!-- Creates the folder navigation -->
  <xsl:template name="layout-folder-nav">
    <div align="center">
      <table border="0">
	<tr>
	  <td width="80" align="right">
	    <xsl:if test="preceding-sibling::folder">
	      <a>
		<xsl:attribute name="href">
		  <xsl:value-of 
		    select="concat(generate-id(preceding::folder),'.html')"/>
		</xsl:attribute>
		&lt;&lt; Previous folder
	      </a>
	    </xsl:if>
	  </td>

	  <td width="80" align="center">
	    <xsl:if test="parent::folder">
	      <a>
		<xsl:attribute name="href">
		  <xsl:value-of 
		    select="concat(generate-id(parent::folder), '.html')"/>
		</xsl:attribute>
		[Up]
	      </a>
	    </xsl:if>
	  </td>

	  <td width="80" align="center">
	    <xsl:if test="parent::folder">
	      <a href="index.html">[Main]</a>
	    </xsl:if>
	  </td>

	  <td width="80" align="left">
	    <xsl:if test="following::folder">
	      <a>
		<xsl:attribute name="href">
		  <xsl:value-of 
		    select="concat(generate-id(following::folder),
		    '.html')"/>
		</xsl:attribute>
		Next folder &gt;&gt;
	      </a>
	    </xsl:if>
	  </td>
	</tr>
      </table>
    </div>
  </xsl:template>

  <!-- **************************************************************** -->
  <!-- IMAGE PAGE -->

  <!-- Creates the head element -->
  <xsl:template name="layout-image-head">
    <head>
      <title><xsl:value-of select="title"/></title>
      <link rel="stylesheet" href="lodju.css" type="text/css"/>
    </head>
  </xsl:template>
  
  <!-- ================================================================ -->
  <!-- Creates the image header -->
  <xsl:template name="layout-image-header">
    <table width="90%" border="0" cellpadding="0" cellspacing="0" bgcolor="#ffffff">
      <tr>
	<td align="left" valign="bottom">
	  <img src="logo_top.gif" alt="Logo top" border="0"/>
	</td>
	<td></td>
      </tr>
      <tr>
	<td align="left" background="fade_bg.gif">
	  <img src="logo_middle.gif" border="0" alt="Logo middle"/>
	</td>
	<td align="right" background="fade.gif">
	  <span class="title">
	    <xsl:value-of select="/folder[1]/name"/>
	  </span>
	</td>
      </tr>
      <tr>
	<td align="left" valign="top">
	  <img src="logo_bottom.gif" border="0" alt="Logo bottom"/>
	</td>
<!--
	<td align="right">
	  <a href="#">&lt;&lt; Previous</a>
	  <xsl:text> </xsl:text>
	  <a href="#">1</a>
	  <xsl:text> | </xsl:text>
	  <a href="#">2</a>
	  <xsl:text> </xsl:text>
	  <a href="#">Next >></a>
	</td>
-->
      </tr>
    </table>
  </xsl:template>
  
  <!-- ================================================================ -->
  <!-- Creates the image navigation -->
  <xsl:template name="layout-image-nav">
    <div align="center">
      <table border="0">
	<tr>
	  <td width="80" align="right">
	    <xsl:if test="preceding-sibling::image[privacy/@level='public']">
	      <a>
	      	<xsl:for-each select="preceding::image[privacy/@level='public']">
		    <xsl:if test="position() = last()">
			<xsl:attribute name="href">
			  <xsl:value-of 
			    select="concat(generate-id(.),'.html')"/>
			</xsl:attribute>
		    </xsl:if>
		</xsl:for-each>
		&lt;&lt; Previous
	      </a>
	    </xsl:if>
	  </td>
	  <td width="80" align="center">
	    <xsl:if test="parent::folder">
	      <a>
		<xsl:attribute name="href">
		  <xsl:value-of 
		    select="concat(generate-id(..), '.html')"/>
		</xsl:attribute>
		[Up]
	      </a>
	    </xsl:if>

	  </td>
	  <td width="80" align="left">
	    <xsl:if test="following-sibling::image[privacy/@level='public']">
	      <a>
		<xsl:attribute name="href">
		  <xsl:value-of 
		    select="concat(generate-id(following::image[privacy/@level='public']),
		    '.html')"/>
		</xsl:attribute>
		Next &gt;&gt;
	      </a>
	    </xsl:if>
	  </td>
	</tr>
      </table>
    </div>
  </xsl:template>

  <!-- ================================================================ -->
  <!-- Creates the image itself -->
  <xsl:template name="layout-image-picture">
    <div align="center">
      <img>
	<xsl:attribute name="src">
	  <xsl:value-of select="concat('medium-', generate-id(), '.jpg')"/>
	</xsl:attribute>
	<xsl:attribute name="alt">
	  <xsl:value-of select="title"/>
	</xsl:attribute>
      </img>
    </div>
  </xsl:template>

  <xsl:template name="layout-image-footer">
    <table width="90%" border="0" cellpadding="0" cellspacing="0" bgcolor="#ffffff">
<!--
      <tr>
	<td colspan="2">
	  <a href="#">&lt;&lt; Previous</a> 
	  <xsl:text> </xsl:text>
	  <a href="#">1</a>
	  <xsl:text> | </xsl:text>
	  <a href="#">2</a> 
	  <xsl:text> </xsl:text>
	  <a href="#">Next >></a>
	</td>
      </tr>
-->
      <tr>
	<td background="footerfill.gif" width="20%">
	  <img src="clear.gif" width="1" height="9" alt=""/>
	</td>
	<td background="footerfade.gif" align="right">
	  <img src="clear.gif" width="1" height="9" alt=""/>
	</td>
      </tr>
    </table>
  </xsl:template>

  <!-- ================================================================ -->
  <!-- Generates a listing of folders in the current context -->
  <xsl:template name="layout-folder-list">

    <xsl:for-each select="./folder[.//image/privacy/@level='public']">
      <xsl:variable name="index-path">
	<xsl:call-template name="make-folder-path"/>
      </xsl:variable>

      <table border="0" cellpadding="0" cellspacing="20" 
	     bgcolor="#ffffff" align="left">
    	<tr>
	    <td>
	      <a href="{$index-path}">
		<img src="image_folder.gif" alt="{name}" 
		     width="120" height="60" border="0"/>
	      </a>
	    </td>
	</tr>
    	<tr>
	    <td>
	      <a href="{@index-path}">
		<xsl:value-of select="name"/>
	      </a>
	    </td>
	</tr>
      </table>
      
      <xsl:if test="round(position() div 4) * 4 = position()">
      	<br clear="all"/>
      </xsl:if>
    </xsl:for-each>

    <xsl:for-each select="./image[privacy/@level='public']">
      <xsl:variable name="index-path">
	<xsl:call-template name="make-folder-path"/>
      </xsl:variable>

      <table border="0" cellpadding="0" cellspacing="20" 
	     bgcolor="#ffffff" align="left">
    	<tr>
	    <td>
	      <a>
		<xsl:attribute name="href">
		  <xsl:value-of select="concat(generate-id(), '.html')"/>
		</xsl:attribute>
		<img>
		  <xsl:attribute name="src">
		    <xsl:text>thumb</xsl:text>
		    <xsl:call-template name="make-image-path"/>
		  </xsl:attribute>
		  <xsl:attribute name="alt">
		    <xsl:value-of select="title"/>
		  </xsl:attribute>
		</img>
	      </a>
	    </td>
	</tr>
    	<tr>
	    <td>
	      <a>
		<xsl:attribute name="href">
		  <xsl:value-of select="concat(generate-id(), '.html')"/>
		</xsl:attribute>
		<xsl:value-of select="title"/>
	      </a>
	    </td>
	</tr>
      </table>
      
      <xsl:if test="round(position() div 4) * 4 = position()">
      	<br clear="all"/>
      </xsl:if>
    </xsl:for-each>

    <br clear="all"/>

<xsl:for-each select="xxx">
    <table width="90%" border="0" cellpadding="0" cellspacing="20" 
           bgcolor="#ffffff">
      <tr>
	<td>
	  <img src="image_folder.gif" alt="A folder of images" 
	       width="120" height="60" border="0"/>
	</td>
	<td>
	  <img src="no_thumb.gif" alt="Image Caption here" width="120" 
	       height="60" border="0"/>
	</td>
	<td>
	  <img src="no_thumb.gif" alt="Image Caption here" width="120" 
	       height="60" border="0"/>
	</td>
	<td>
	  <img src="no_thumb.gif" alt="Image Caption here" width="120" 
	       height="60" border="0"/>
	</td>
      </tr>
      <tr>
	<td>A folder of images</td>
	<td>Image caption here</td>
	<td>Image caption here</td>
	<td>Image caption here</td>
      </tr>
    </table>



    <div align="center">
      <h3>Image folders</h3>
      <table border="0">
	<xsl:for-each select="./folder[.//image/privacy/@level='public']">
	  
	  <!-- Determine the path to the index file -->
	  <xsl:variable name="index-path">
	    <xsl:call-template name="make-folder-path"/>
	  </xsl:variable>
	  
	  <tr>
	    <td>
	      <p>
		<img src="graphics/folder.png">
		  <xsl:attribute name="alt">
		    <xsl:value-of select="name"/>
		  </xsl:attribute>
		</img>
	      </p>
	    </td>
	    <td>
	      <a>
		<xsl:attribute name="href">
		  <xsl:value-of select="$index-path"/>
		</xsl:attribute>
		
		<xsl:value-of select="name"/>
	      </a>
	    </td>
	  </tr>
	  
	</xsl:for-each>
      </table>
    </div>
</xsl:for-each>

  </xsl:template>

  <!-- ================================================================ -->
  <!-- Generates a listing of images in the current context -->
  <xsl:template name="layout-image-list">

    <table>
      <xsl:for-each select="./image[privacy/@level='public']">
	
	<tr>
	  <!-- Image thumbnail -->
	  <td>
	    <a>
	      <xsl:attribute name="href">
		<xsl:value-of select="concat(generate-id(), '.html')"/>
	      </xsl:attribute>
	      <img>
		<xsl:attribute name="src">
		  <xsl:text>thumb</xsl:text>
		  <xsl:call-template name="make-image-path"/>
		</xsl:attribute>
		<xsl:attribute name="alt">
		  <xsl:value-of select="title"/>
		</xsl:attribute>
	      </img>
	    </a>
	  </td>
	  
	  <!-- Image caption -->
	  <td>
	    <p>
	      <a>
		<xsl:attribute name="href">
		  <xsl:value-of select="concat(generate-id(), '.html')"/>
		</xsl:attribute>
		<xsl:value-of select="title"/>
	      </a>
	    </p>
	  </td>
	</tr>
	
      </xsl:for-each>
    </table>
    
  </xsl:template>

  
</xsl:stylesheet>
